RequireScript("datatools.js");
RequireScript("Elemente.js");

function Kristallgeist(){

	this.element = undefined;
	this.released = false;
	this.name = undefined;
	this.spriteset = undefined;


}

Kristallgeist.prototype.showUp = function(){

	switch(this.element){
	
		case Element[1]:
			
			dialog.showText("muh");
		
			break;
	
	}

}


function TryGenerateKristallgeist(id){

	var k = new Kristallgeist();
	switch (id){
		default:
		case 0:
			k.element = 1;
			k.released = kristallgeistsystem.releasedGhosts[id]
			k.name = "Ferly"
			k.spriteset = "Kristallgeist_Efles.rss"
	}
	
	return k;

}



//////////////////////////


function KristallgeistSystem(){
	
	this.releasedGhosts = createFalseArray(100);

}


KristallgeistSystem.prototype.save = function(file){

	file.write(this.releasedGhosts.length);
	for(var i=0;i<this.releasedGhosts.length;i++){
		
		file.write(this.releasedGhosts[i]?1:0);
		
		}	

}


KristallgeistSystem.prototype.load = function(file){

	var boxarr= file.readInt();
	
	for(var i=0;i<boxarr;i++){
		
		if(file.readInt()==1)
			this.releasedGhosts[i]=true;
		else
			this.releasedGhosts[i]=false;
		
		}
	}



KristallgeistSystem.prototype.tryGenerateKristall = function(id){

	if(this.releasedGhosts[id]){
	
		SetPersonDirection(GetCurrentPerson(),"north");
	
	}
	else{
	
		SetPersonDirection(GetCurrentPerson(),"south");
	
	}


}

KristallgeistSystem.prototype.tryActivateKristall = function(id){
	enemysystem.pause = true;
	personcontroller.lockAllInputProfile(true,undefined);
	
	if(this.releasedGhosts[id]){
		
		langmodule.setMode("system");
		dialog.think(g_maincharacter,langmodule.getString("S_GHOSTEMPTY"));
		langmodule.setLastMode();
	
	}
	else{
	
		var kg = TryGenerateKristallgeist(id);
		
		ReleaseKristallgeistAnimation(kg,GetCurrentPerson());
		
		HideKristallgeistAnimation(kg,GetCurrentPerson(),(this.releasedGhosts[id] = ShowKristallgeistMenu(kg)));
	
	}
	
	personcontroller.lockAllInputProfile(false,undefined);
	enemysystem.pause = false;
}

function ReleaseKristallgeistAnimation(kg,kristallname){
	
	switch(kg.element){
	
		case 1: 
		
			RKA_Fire01(kg,kristallname);
			
			break;
	
	
	}
	
}

function HideKristallgeistAnimation(kg,kristallname,setFree){
	
	var tmpc = CreateColor(Element[kg.element].farbe.red,Element[kg.element].farbe.green,Element[kg.element].farbe.blue,255);
	SetColorMask(tmpc,10);
	MapDelay(10);
	
	layerrendermanager.removeScript(GetPersonLayer(kristallname),"KRISTALLGEIST_ANIMATION");
	
	DestroyPerson(kristallname+"_geist");
	if(!setFree){
		
		SetPersonDirection(kristallname,"south");
		
	}
	
	
	tmpc.alpha = 0;
	SetColorMask(tmpc,70);
	MapDelay(70);
	
}

function RKA_Fire01(kg,kristallname){

	var layer = GetPersonLayer(kristallname);
	
	var script = "\
		for(var i=0;i<layerrendermanager.getVars("+layer+",\"RELEASE_KRISTALLGEIST\")[0].length;i++)\
			layerrendermanager.getVars("+layer+",\"RELEASE_KRISTALLGEIST\")[0][i].render();\
			";
	
	var psa = [
		PS_Preset_Fire(),
		PS_Preset_Fire(),
		PS_Preset_Fire(),
		PS_Preset_Fire(),
		PS_Preset_Fire(),
		PS_Preset_Fire(),
		PS_Preset_Fire(),
		PS_Preset_Fire()
		]	
	
	layerrendermanager.addScript(layer,"RELEASE_KRISTALLGEIST",script,[psa])
	
	for(var i=0;i<psa.length;i++){
		psa[i].startProduce();
	}
	var flyspeed = 0;
	var distance = 70;
	var posx= MapToScreenX(layer,GetPersonX(kristallname));
	var posy= MapToScreenY(layer,GetPersonY(kristallname));
	
	var tm = new TimeMonitor(6000);
	tm.start();
	while(tm.getPercent()<30){
		
		for(var i=0;i<psa.length;i++){
			psa[i].startPosition=[posx+Math.cos(Math.PI/4*i)*distance,posy+Math.sin(Math.PI/4*i)*distance];
		}
		
		MapDelay(1);
		}
		
	var tmpper = 0;
	while((tmpper=tm.getPercent())<100){
		distance = 100-tmpper;
		flyspeed+=0.01;
		for(var i=0;i<psa.length;i++){
			psa[i].startPosition=[posx+Math.cos(flyspeed+Math.PI/4*i)*distance,posy+Math.sin(flyspeed+Math.PI/4*i)*distance];
		}
		
		MapDelay(1);
		}
	tm.stop();
	for(var i=1;i<psa.length;i++){
			psa[i].stopProduce();
		}
	
	CreatePerson(kristallname+"_geist",kg.spriteset,true)
	SetPersonX(kristallname+"_geist",GetPersonX(kristallname));
	SetPersonY(kristallname+"_geist",GetPersonY(kristallname)-64);
	var kglayer = Math.min(GetNumLayers()-1,GetPersonLayer(kristallname)+1)
	SetPersonLayer(kristallname+"_geist",kglayer);
	
	
	
	var ps = new ParticleSystem();
	
	ps.produceDelay = 2;
	ps.images = [objectsystem.image.get("effekt/e_kugel.png")];
	
	//ps.startPositionVar = [3,3];
	ps.startRotationVar = 360;
	ps.flyRotation = 0.25;
	ps.flyRotationVar = -0.5;
	ps.startSize = [3,60];
	ps.startSizeVar = [10,10];
	
	ps.flySize = [0,-1];
	//ps.flyPositionVar = [-0.2,-1];
	ps.startColor = [255,255,0,0];
	ps.startColorVar = [0,-155,100,0];
	ps.flyColor = [0,0,0,10];
	
	
	ps.particleLifetime = 50;
	ps.fadeOutAtPercent = 70;
	ps.maxParticles = 50;
	//ps.startPosition = [GetPersonX(kristallname+"_geist"),GetPersonY(kristallname+"_geist")];
	
	ps.startProduce();
	
	
	var aniscript = "\
		SetPersonX(\""+kristallname+"_geist\",GetPersonX(\""+kristallname+"\")+Math.cos(GetTime()/2000)*5-20);\
		SetPersonY(\""+kristallname+"_geist\",GetPersonY(\""+kristallname+"\")+Math.sin(GetTime()/200)*5-100);\
		SetPersonDirection(\""+kristallname+"_geist\",\"south\");\
		layerrendermanager.getVars("+layer+",\"KRISTALLGEIST_ANIMATION\")[0].startPosition =\
			[GetPersonX(\""+kristallname+"_geist\")+14,GetPersonY(\""+kristallname+"_geist\")+16];\
		layerrendermanager.getVars("+layer+",\"KRISTALLGEIST_ANIMATION\")[0].renderWithMapTransformation("+layer+");\
		";
	layerrendermanager.addScript(layer,"KRISTALLGEIST_ANIMATION",aniscript,[ps])
	
	
	
	SetPersonDirection(kristallname,"north");
		
	var tm = new TimeMonitor(1000);
	tm.start();
	while((tmpper=tm.getPercent())<100){
	
		psa[0].startSize = [100-tmpper,100-tmpper];
		psa[0].startColor[3] = (100-tmpper)/100*255;
		psa[0].flyPosition[1] = -5*(100-tmpper)/100;
		psa[0].startPositionVar[0] = tmpper/2;
		psa[0].startPosition[0] = posx-tmpper/4;
		MapDelay(1);
	}
	psa[0].stopProduce();
	
	layerrendermanager.removeScript(layer,"RELEASE_KRISTALLGEIST");
	
	
	


}

function ShowKristallgeistMenu(kg){

	langmodule.setMode("system");
  var tmpcheck=true;
  var tmpimg=undefined;
  var tmpa=true;
  var tmpv=0;
  var tmpt = 0;
  var sel=0;
  var aus=0;
  var tmpstr;
  var tmpge;
  var tmpCanLevelUp = false;
  var tmpblck = CreateColor(0,0,0);
  var tmpeleclr = CreateColor(Element[kg.element].farbe.red,Element[kg.element].farbe.green,Element[kg.element].farbe.blue);
  var tmpkgimg = objectsystem.image.get("kristallgeist/efles_front.png");
  var tmpkgclr = CreateColor(255,255,255,0);
  var tmpgrey = CreateColor(255,255,255,180);
  var tmpNextLv = 0;
  
  langmodule.setMode("system");
  var tmptxt = [
		langmodule.getString("S_EBENE"),				//0
		langmodule.getString("S_KG_MAXELEMENT"),//1
		langmodule.getString("S_KG_ELEMENTOK"), //2
		langmodule.getString("S_KP"),						//3
		langmodule.getString("S_ELEMENT"),			//4
		langmodule.getString("S_KRISTALLGEIST"),//5
		langmodule.getString("S_OKTOCONT")			//6
		];
  MapDelay(100);
  
  var tm = new TimeMonitor(700);
  tm.start();
  var tmpper;
  
  
  while((tmpper=tm.getPercent())<100){
		tmpblck.alpha = tmpper*1.8;
		tmpkgclr.alpha = tmpblck.alpha;
		UpdateMapEngine();
		RenderMap();
		Rectangle(0,GetScreenHeight()/4/100*tmpper,GetScreenWidth(),GetScreenHeight()-GetScreenHeight()/2/100*tmpper,tmpblck);
		Line(0,GetScreenHeight()/4/100*tmpper,GetScreenWidth(),GetScreenHeight()/4/100*tmpper,Element[kg.element].farbe)
		Line(0,GetScreenHeight()-GetScreenHeight()/4/100*tmpper,GetScreenWidth(),GetScreenHeight()-GetScreenHeight()/4/100*tmpper,Element[kg.element].farbe)
		tmpkgimg.blitMask(GetScreenWidth()-300,GetScreenHeight()/2-150,tmpkgclr);
		FlipScreenFps();
  
  }
  tmpper=100;
  
  while(!IsKeyPressed(btn_OK)){
		tmpblck.alpha = 180;
		tmpkgclr.alpha = 180;
		UpdateMapEngine();
		RenderMap();
		Rectangle(0,GetScreenHeight()/4/100*tmpper,GetScreenWidth(),GetScreenHeight()-GetScreenHeight()/2/100*tmpper,tmpblck);
		Line(0,GetScreenHeight()/4/100*tmpper,GetScreenWidth(),GetScreenHeight()/4/100*tmpper,Element[kg.element].farbe)
		Line(0,GetScreenHeight()-GetScreenHeight()/4/100*tmpper,GetScreenWidth(),GetScreenHeight()-GetScreenHeight()/4/100*tmpper,Element[kg.element].farbe)
		tmpkgimg.blitMask(GetScreenWidth()-300,GetScreenHeight()/2-150,tmpkgclr);
		
		cfont.setColorMask(Element[kg.element].farbe);
		
		font.drawText(GetScreenWidth()/8,GetScreenHeight()/2-font.getHeight()*3,tmptxt[5]+":");
		cfont.drawText(GetScreenWidth()/8+20,GetScreenHeight()/2-font.getHeight()*2,kg.name);
		
		font.drawText(GetScreenWidth()/8,GetScreenHeight()/2+font.getHeight(),tmptxt[4]+":");
		cfont.drawText(GetScreenWidth()/8+20,GetScreenHeight()/2+font.getHeight()*2,Element[kg.element].name);
		
		cfont.setColorMask(tmpgrey);
		cfont.drawText(GetScreenWidth()/4,GetScreenHeight()/2+font.getHeight()*5,tmptxt[6]);
		
		FlipScreenFps();
  }
  
  tm.stop();
  tm.setLength(700);
  tm.start();
  while((tmpper=100-tm.getPercent())>0){
		tmpkgclr.alpha = tmpper*1.8+(100-tmpper*0.5);
		UpdateMapEngine();
		RenderMap();
		GradientRectangle(0,GetScreenHeight()/4/100*tmpper,GetScreenWidth(),GetScreenHeight()-GetScreenHeight()/2/100*tmpper,tmpblck,tmpblck,BlendColorsWeighted(tmpblck,tmpeleclr,tmpper/100,1-tmpper/100),BlendColorsWeighted(tmpblck,tmpeleclr,tmpper/100,1-tmpper/100));
		Line(0,GetScreenHeight()/4/100*tmpper,GetScreenWidth(),GetScreenHeight()/4/100*tmpper,Element[kg.element].farbe)
		Line(0,GetScreenHeight()-GetScreenHeight()/4/100*tmpper,GetScreenWidth(),GetScreenHeight()-GetScreenHeight()/4/100*tmpper,Element[kg.element].farbe)
		tmpkgimg.blitMask(GetScreenWidth()-300,GetScreenHeight()/2-150,tmpkgclr);
		FlipScreenFps();
  
  }
  
  RenderMap();
  var tmpmap = GrabImage(0,0,640,480);
  
  
  tmpkgclr.alpha = 50;
  ClearKey();
  while(true){
		if(tmpcheck){
			
			tmpmap.blit(0,0);
			GradientRectangle(0,0,GetScreenWidth(),GetScreenHeight(),tmpblck,tmpblck,tmpeleclr,tmpeleclr);
			tmpkgimg.blitMask(GetScreenWidth()-300,GetScreenHeight()/2-150,tmpkgclr);			
			windowm.drawWindow(20,20,150,font.getHeight()*party.members.length);
			windowm.drawWindow(190,20,GetScreenWidth()-230,cfont.getHeight()*24);
			for(var i=0;i<party.members.length;i++){
				font.drawText(40,20+i*font.getHeight(),party.members[i].name);
				}
			
			for(var i=0;i<Element.length;i++){
			
				cfont.setColorMask(Element[i].farbe);
				cfont.drawText(200,20+i*cfont.getHeight()*3,Element[i].name);
				tmpge = 0;
				mfont.setColorMask(Element[i].farbe);
								
				if(party.members[aus].KPin1[i]>0){
					mfont.drawText(220,20+i*cfont.getHeight()*3+cfont.getHeight(),tmptxt[3]+": "+party.members[aus].KPin1[i]);
					Rectangle(270,20+i*cfont.getHeight()*3+cfont.getHeight()+2,GetScreenWidth()-320,5,tmpblck);
					Rectangle(270,20+i*cfont.getHeight()*3+cfont.getHeight()+3,(GetScreenWidth()-320)*party.members[aus].KPin1[i]/1000,3,Element[i].farbe);
					if(party.members[aus].KPin2[i]>0){
						mfont.drawText(220,20+i*cfont.getHeight()*3+cfont.getHeight()+mfont.getHeight()*1,tmptxt[3]+": "+party.members[aus].KPin2[i]);
						Rectangle(270,20+i*cfont.getHeight()*3+cfont.getHeight()+mfont.getHeight()*1+2,GetScreenWidth()-320,5,tmpblck);
						Rectangle(270,20+i*cfont.getHeight()*3+cfont.getHeight()+mfont.getHeight()*1+3,(GetScreenWidth()-320)*party.members[aus].KPin2[i]/1000,3,Element[i].farbe);
						if(party.members[aus].KPin3[i]>0){
							mfont.drawText(220,20+i*cfont.getHeight()*3+cfont.getHeight()+mfont.getHeight()*2,tmptxt[3]+": "+party.members[aus].KPin3[i]);
							Rectangle(270,20+i*cfont.getHeight()*3+cfont.getHeight()+mfont.getHeight()*2+2,GetScreenWidth()-320,5,tmpblck);
							Rectangle(270,20+i*cfont.getHeight()*3+cfont.getHeight()+mfont.getHeight()*2+3,(GetScreenWidth()-320)*party.members[aus].KPin3[i]/1000,3,Element[i].farbe);
							tmpge++;
							}
						tmpge++;
						}
					tmpge++;
					}
				if(i==kg.element){
					tmpNextLv = tmpge+1;
					if(tmpge>2){
						if(tmpCanLevelUp)tmpt=0;
						tmpCanLevelUp=false;
						}
					else{
						if(!tmpCanLevelUp)tmpt=0;
						tmpCanLevelUp=true;
						}
					}
				tmpstr = tmptxt[0]+": "+tmpge;
				statusfont.drawText(190+GetScreenWidth()-230-statusfont.getStringWidth(tmpstr),20+i*cfont.getHeight()*3,tmpstr);
				}
			tmpimg=GrabImage(0,0,640,480);
			tmpcheck=false;
			}
		while(!AreKeysLeft()){
			tmpimg.blit(0,0);
			if(tmpa){
				tmpv+=0.5;
				}
			else{
				tmpv-=0.5;
				}
			if(tmpv==3)tmpa=false;
			if(tmpv==-3)tmpa=true;
			
			GlobalCursor.setPos(10,20+aus*font.getHeight());
			GlobalCursor.blit(tmpv,0);
			
			tmpt++;
			RenderHelpLine(450,(tmpCanLevelUp?tmptxt[2]:tmptxt[1]),tmpt,tmpblck);
			
			FlipScreenFps();
			}
		while(AreKeysLeft()){
			switch(GetKey()){
			 case btn_RIGHT:{

					 tmpcheck=true;
					 ClearKey();
					 break;
					 }
			 case btn_LEFT:{

					 tmpcheck=true;
					 ClearKey();
					 break;
					 }
			 case btn_DOWN:{
					 aus=(aus+1)%party.members.length;
					 tmpcheck=true;
					 ClearKey();
					 break;
					 }
			 case btn_UP:{
					 if(aus==0)
						aus=party.members.length;
					 aus=(aus-1)%party.members.length;
					 tmpcheck=true;
					 ClearKey();
					 break;
					 } 
			 case btn_CANCEL:{
					 menusound.play("CANCEL");
					 tmpcheck=true;
					 ClearKey();
					 tm.stop();
					 tm.setLength(700);
					 tm.start();
					 while((tmpper=100-tm.getPercent())>0){
						tmpeleclr.alpha = tmpper*2.55;
						tmpblck.alpha = tmpper*1.8;
						tmpkgclr.alpha = tmpper*0.5;
						RenderMap();
						GradientRectangle(0,0,GetScreenWidth(),GetScreenHeight(),tmpblck,tmpblck,tmpeleclr,tmpeleclr);
						tmpkgimg.blitMask(GetScreenWidth()-300,GetScreenHeight()/2-150,tmpkgclr);
						FlipScreenFps();					
						}
					 return false;
					 }
			 case btn_OK:{
					 if(!tmpCanLevelUp){
						menusound.play("CANCEL");
						tmpcheck=true;
						ClearKey();
						break;
						}
					 					 
					 menusound.play("OK");
					 ClearKey();
					 tmpcheck=true;
					 tm.stop();
					 tm.setLength(30);
					 tm.start();
					 while((tmpper=100-tm.getPercent())>0){
						tmpkgclr.alpha = tmpper*0.5;
						tmpmap.blit(0,0);
						GradientRectangle(0,0,GetScreenWidth(),GetScreenHeight(),tmpblck,tmpblck,tmpeleclr,tmpeleclr);
						tmpkgimg.blitMask(GetScreenWidth()-300,GetScreenHeight()/2-150,tmpkgclr);
						FlipScreenFps();					
						}
					 var tmpspriteimgs = GetImagesFromSpriteset(LoadSpriteset(party.members[aus].charset),"south");
					 
					  tmpmap.blit(0,0);
						GradientRectangle(0,0,GetScreenWidth(),GetScreenHeight(),tmpblck,tmpblck,tmpeleclr,tmpeleclr);
						tmpimg = GrabImage(0,0,GetScreenWidth(),GetScreenHeight());
					 
					 var tmpps = PS_Preset_LearnElement(Element[kg.element].farbe.red,Element[kg.element].farbe.green,Element[kg.element].farbe.blue);
					 tmpps.startProduce();
					 tm.stop();
					 tm.setLength(5000);
					 tm.start();
					 while((tmpper=tm.getPercent())<100){
						
						//tmpps.flyPosition = [Math.sin(GetTime()/1000)*tmpper/100*5,Math.cos(GetTime()/1000)*tmpper/100*5];
						tmpps.flyColor[3] = 100-tmpper;
						tmpps.flySize = [10*tmpper/100,10*tmpper/100];
						tmpimg.blit(0,0);
						
						tmpps.render();
						
						tmpspriteimgs[0].blit(GetScreenWidth()/2-tmpspriteimgs[0].width/2,GetScreenHeight()/2-tmpspriteimgs[0].height/2)
						
						if(tmpper>20)
							font.drawText(GetScreenWidth()/2-font.getStringWidth(party.members[aus].name)/2,40,party.members[aus].name);
						if(tmpper>40)
							font.drawText(GetScreenWidth()/2-font.getStringWidth(Element[kg.element].name)/2,40+font.getHeight()*2,Element[kg.element].name);
						if(tmpper>60)
							font.drawText(GetScreenWidth()/2-font.getStringWidth(tmptxt[0])/2,40+font.getHeight()*4,tmptxt[0]);							
						if(tmpper>80){	
							cfont.setColorMask(Element[kg.element].farbe);
							
							cfont.drawZoomedText(GetScreenWidth()/2-cfont.getStringWidth(tmpNextLv)/2*(1+100*(1-tmpper/100)),40+cfont.getHeight()*5,1+100*(1-tmpper/100),tmpNextLv);
						}
						
						FlipScreenFps();
					 }
					 
					 while(!IsKeyPressed(btn_OK)){
						
						tmpimg.blit(0,0);
						tmpps.render();
						tmpspriteimgs[0].blit(GetScreenWidth()/2-tmpspriteimgs[0].width/2,GetScreenHeight()/2-tmpspriteimgs[0].height/2)
						
						font.drawText(GetScreenWidth()/2-font.getStringWidth(party.members[aus].name)/2,40,party.members[aus].name);
						font.drawText(GetScreenWidth()/2-font.getStringWidth(Element[kg.element].name)/2,40+font.getHeight()*2,Element[kg.element].name);
						font.drawText(GetScreenWidth()/2-font.getStringWidth(tmptxt[0])/2,40+font.getHeight()*4,tmptxt[0]);			
						cfont.setColorMask(Element[kg.element].farbe);
						cfont.drawText(GetScreenWidth()/2-cfont.getStringWidth(tmpNextLv)/2,40+cfont.getHeight()*5,tmpNextLv);
						cfont.setColorMask(tmpgrey);
						cfont.drawText(GetScreenWidth()/2-cfont.getStringWidth(tmptxt[6])/2,GetScreenHeight()-font.getHeight()*4,tmptxt[6]);
						FlipScreenFps();
					 
					 }
					 
					 switch(tmpNextLv){
						case 1: party.members[aus].KPin1[kg.element]=1;break;
						case 2: party.members[aus].KPin2[kg.element]=1;break;
						case 3: party.members[aus].KPin3[kg.element]=1;break;
						}
					 
					 tmpps.stopProduce();

					 return true;
					 break;
					 }                              
         }
			}
		}
	
	while(true)MapDelay(1);
	return false;

}

kristallgeistsystem =  new KristallgeistSystem();